unit CFNamer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,DSGNINTF, CNamer;

type

  TComponentPropertyEditor = class(TPropertyEditor)
  public
    { Public declarations }
    Function GetAttributes:TPropertyAttributes; Override;
    Function GetValue : String; Override;
    Procedure Edit; Override;
  published
    { Published declarations }
  end;

  TFCompon = class(TForm)
    CompListen: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure Register;

implementation

{$R *.DFM}

Function TComponentPropertyEditor.GetValue : String;
Begin
  Result := Format('%S', [GetPropType^.Name]);
End;

Function TComponentPropertyEditor.GetAttributes:TPropertyAttributes;
Begin
  Result := [PaDialog, PaReadOnly];
End;

Procedure TComponentPropertyEditor.Edit;
Var
  CompView    : TFCompon;
  ComponenterN: TComponentNamer;
  I           : Integer;
Begin
  CompView := TFCompon.Create(Application);
  Try
    ComponenterN := GetComponent(0) As TComponentNamer;
    ComponenterN.FAendreList.Clear;
    CompView.CompListen.Items.Assign(ComponenterN.Componenter);
    If CompView.ShowModal = MrOk Then Begin
      // Her skal den s aendre componentnavne.
      For I := 0 To CompView.CompListen.Items.Count-1 Do
      Begin
        If CompView.CompListen.Selected[I] Then Begin
          ComponenterN.FAendreList.Add(CompView.CompListen.Items[I]);
        End;
        Designer.Modified;
      End;
    End;
  Finally
    CompView.Free;
  End;
End;

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(TStringList),TComponentNamer,'Componenter',
                         TComponentPropertyEditor);
end;

end.
